
#ifndef HIN_CONF_H
#define HIN_CONF_H

#define HIN_CONF_PATH "workdir/main.lua"
#define HIN_LOGDIR_PATH "workdir/logs/"
#define HIN_WORKDIR_PATH "./"
#define HIN_TEMP_PATH "/tmp/"
#define HIN_DEBUG_MASK 0x20007

#define HIN_URING_QUEUE_DEPTH 256
#define HIN_URING_DONT_FORK 0
#define HIN_URING_REDUCE_SYSCALLS 1

#define HIN_SOCKET_REUSEADDR 1

#define HIN_USE_SIGNAL_FD 1
#define HIN_RLIMIT_MEMLOCK ((long)0x100000)
#define HIN_RLIMIT_NOFILE ((long)2048)

// 1 for warning, 2 for program abort
#define HIN_RESTRICT_ROOT 1

#define HIN_HTTPD_TIMEOUT 10
// in miliseconds
#define HIN_HTTPD_TIME_DT 200
#define HIN_HTTPD_MAX_HEADER_SIZE 65000
#define HIN_HTTPD_MAX_HEADER_LINE_SIZE 4096
#define HIN_HTTPD_MAX_POST_SIZE 4121440
#define HIN_HTTPD_MAX_COMPRESS_SIZE 0
#define HIN_HTTPD_POST_DIRECTORY HIN_TEMP_PATH
#define HIN_HTTPD_CACHE_DIRECTORY "cache"
#define HIN_HTTPD_CACHE_CLEAN_ON_EXIT 1
#define HIN_HTTPD_CACHE_TMPFILE 0
#define HIN_HTTPD_CACHE_MAX_SIZE 64 * 1024 * 1024
#define HIN_HTTPD_SERVER_BANNER "hinsightd 0.9"
#define HIN_HTTPD_PROXY_CONNECTION_REUSE 1
#define HIN_HTTPD_OVERLOAD_ERROR 0
#define HIN_HTTPD_ERROR_ON_MISSING_CERT 0
#define HIN_HTTPD_ERROR_MISSING_HOSTNAME 0

#define HIN_HTTPD_WORKER_NUM 1
#define HIN_HTTPD_WORKER_MAX_QUEUE 16
#define HIN_HTTPD_WORKER_PREFORKED 0
#define HIN_HTTPD_DISABLE_POWERED_BY 0
#define HIN_HTTPD_CGI_CHUNKED_UPLOAD 0

#define HIN_HTTPD_ASYNC_OPEN 1
#define HIN_HTTPD_ASYNC_STATX 0
#define HIN_HTTPD_NULL_SERVER 0

#define HIN_LINUX_BUG_5_11_3
#define HIN_LINUX_URING_DONT_HAVE_SIGNALFD
#define HIN_LINUX_URING_DONT_HAVE_NOTIFYFD

#endif

